Index: trunk/src/VBox/Additions/WINNT/SharedFolders/driver/file.c
===================================================================
--- trunk/src/VBox/Additions/WINNT/SharedFolders/driver/file.c	(revision 78279)
+++ trunk/src/VBox/Additions/WINNT/SharedFolders/driver/file.c	(revision 78280)
@@ -238,5 +238,5 @@
     PVOID pbUserBuffer = RxLowIoGetBufferAddress(RxContext);
 
-    int vboxRC;
+    int vrc;
 
 #ifdef LOG_ENABLED
@@ -293,9 +293,9 @@
     ctx.pfnTransferPages = vbsfTransferPagesRead;
 
-    vboxRC = vbsfTransferCommon(&ctx);
+    vrc = vbsfTransferCommon(&ctx);
 
     ByteCount = ctx.cbData;
 
-    Status = VBoxErrorToNTStatus(vboxRC);
+    Status = VBoxErrorToNTStatus(vrc);
 
     if (Status != STATUS_SUCCESS)
@@ -363,5 +363,5 @@
     PVOID pbUserBuffer = RxLowIoGetBufferAddress(RxContext);
 
-    int vboxRC;
+    int vrc;
 
 #ifdef LOG_ENABLED
@@ -398,9 +398,9 @@
     ctx.pfnTransferPages = vbsfTransferPagesWrite;
 
-    vboxRC = vbsfTransferCommon(&ctx);
+    vrc = vbsfTransferCommon(&ctx);
 
     ByteCount = ctx.cbData;
 
-    Status = VBoxErrorToNTStatus(vboxRC);
+    Status = VBoxErrorToNTStatus(vrc);
 
     if (Status != STATUS_SUCCESS)
@@ -462,5 +462,5 @@
     PLOWIO_CONTEXT LowIoContext = &RxContext->LowIoContext;
     uint32_t fu32Lock = 0;
-    int vboxRC;
+    int vrc;
 
     Log(("VBOXSF: MRxLocks: Operation %d\n",
@@ -498,8 +498,8 @@
         fu32Lock |= SHFL_LOCK_WAIT;
 
-    vboxRC = VbglR0SfLock(&pDeviceExtension->hgcmClient, &pNetRootExtension->map, pVBoxFobx->hFile,
-                          LowIoContext->ParamsFor.Locks.ByteOffset, LowIoContext->ParamsFor.Locks.Length, fu32Lock);
-
-    Status = VBoxErrorToNTStatus(vboxRC);
+    vrc = VbglR0SfLock(&pDeviceExtension->hgcmClient, &pNetRootExtension->map, pVBoxFobx->hFile,
+                       LowIoContext->ParamsFor.Locks.ByteOffset, LowIoContext->ParamsFor.Locks.Length, fu32Lock);
+
+    Status = VBoxErrorToNTStatus(vrc);
 
     Log(("VBOXSF: MRxLocks: Returned 0x%08X\n", Status));
@@ -526,12 +526,12 @@
     PMRX_VBOX_FOBX pVBoxFobx = VBoxMRxGetFileObjectExtension(capFobx);
 
-    int vboxRC;
+    int vrc;
 
     Log(("VBOXSF: MRxFlush\n"));
 
     /* Do the actual flushing of file buffers */
-    vboxRC = VbglR0SfFlush(&pDeviceExtension->hgcmClient, &pNetRootExtension->map, pVBoxFobx->hFile);
-
-    Status = VBoxErrorToNTStatus(vboxRC);
+    vrc = VbglR0SfFlush(&pDeviceExtension->hgcmClient, &pNetRootExtension->map, pVBoxFobx->hFile);
+
+    Status = VBoxErrorToNTStatus(vrc);
 
     Log(("VBOXSF: MRxFlush: Returned 0x%08X\n", Status));
@@ -554,5 +554,5 @@
     PSHFLFSOBJINFO pObjInfo;
     uint32_t cbBuffer;
-    int vboxRC;
+    int vrc;
 
     Log(("VBOXSF: vbsfSetEndOfFile: New size = %RX64 (%p), pNewAllocationSize = %p\n",
@@ -572,10 +572,10 @@
     pObjInfo->cbObject = pNewFileSize->QuadPart;
 
-    vboxRC = VbglR0SfFsInfo(&pDeviceExtension->hgcmClient, &pNetRootExtension->map, pVBoxFobx->hFile,
-                            SHFL_INFO_SET | SHFL_INFO_SIZE, &cbBuffer, (PSHFLDIRINFO)pObjInfo);
-
-    Log(("VBOXSF: vbsfSetEndOfFile: VbglR0SfFsInfo returned %Rrc\n", vboxRC));
-
-    Status = VBoxErrorToNTStatus(vboxRC);
+    vrc = VbglR0SfFsInfo(&pDeviceExtension->hgcmClient, &pNetRootExtension->map, pVBoxFobx->hFile,
+                         SHFL_INFO_SET | SHFL_INFO_SIZE, &cbBuffer, (PSHFLDIRINFO)pObjInfo);
+
+    Log(("VBOXSF: vbsfSetEndOfFile: VbglR0SfFsInfo returned %Rrc\n", vrc));
+
+    Status = VBoxErrorToNTStatus(vrc);
     if (Status == STATUS_SUCCESS)
     {
Index: trunk/src/VBox/Additions/WINNT/SharedFolders/driver/info.c
===================================================================
--- trunk/src/VBox/Additions/WINNT/SharedFolders/driver/info.c	(revision 78279)
+++ trunk/src/VBox/Additions/WINNT/SharedFolders/driver/info.c	(revision 78280)
@@ -50,5 +50,5 @@
 
     LONG cbToCopy;
-    int vboxRC;
+    int vrc;
     uint8_t *pHGCMBuffer;
     uint32_t index, fSFFlags, cFiles, u32BufSize;
@@ -178,10 +178,10 @@
     Log(("VBOXSF: MrxQueryDirectory: CallDirInfo: File = 0x%08x, Flags = 0x%08x, Index = %d, u32BufSize = %d\n",
          pVBoxFobx->hFile, fSFFlags, index, u32BufSize));
-    vboxRC = VbglR0SfDirInfo(&pDeviceExtension->hgcmClient, &pNetRootExtension->map, pVBoxFobx->hFile,
-                             ParsedPath, fSFFlags, index, &u32BufSize, (PSHFLDIRINFO)pHGCMBuffer, &cFiles);
+    vrc = VbglR0SfDirInfo(&pDeviceExtension->hgcmClient, &pNetRootExtension->map, pVBoxFobx->hFile,
+                          ParsedPath, fSFFlags, index, &u32BufSize, (PSHFLDIRINFO)pHGCMBuffer, &cFiles);
     Log(("VBOXSF: MrxQueryDirectory: u32BufSize after CallDirInfo = %d, rc = %Rrc\n",
-         u32BufSize, vboxRC));
-
-    switch (vboxRC)
+         u32BufSize, vrc));
+
+    switch (vrc)
     {
         case VINF_SUCCESS:
@@ -222,7 +222,7 @@
 
         default:
-            Status = VBoxErrorToNTStatus(vboxRC);
+            Status = VBoxErrorToNTStatus(vrc);
             Log(("VBOXSF: MrxQueryDirectory: Error %Rrc from CallDirInfo (cFiles=%d)!\n",
-                 vboxRC, cFiles));
+                 vrc, cFiles));
             break;
     }
@@ -555,5 +555,5 @@
             uint32_t cbHGCMBuffer;
             uint8_t *pHGCMBuffer;
-            int vboxRC;
+            int vrc;
 
             Log(("VBOXSF: MrxQueryVolumeInfo: FileFsVolumeInformation\n"));
@@ -600,10 +600,10 @@
             }
 
-            vboxRC = VbglR0SfFsInfo(&pDeviceExtension->hgcmClient, &pNetRootExtension->map, pVBoxFobx->hFile,
-                                    SHFL_INFO_GET | SHFL_INFO_VOLUME, &cbHGCMBuffer, (PSHFLDIRINFO)pHGCMBuffer);
-
-            if (vboxRC != VINF_SUCCESS)
-            {
-                Status = VBoxErrorToNTStatus(vboxRC);
+            vrc = VbglR0SfFsInfo(&pDeviceExtension->hgcmClient, &pNetRootExtension->map, pVBoxFobx->hFile,
+                                 SHFL_INFO_GET | SHFL_INFO_VOLUME, &cbHGCMBuffer, (PSHFLDIRINFO)pHGCMBuffer);
+
+            if (vrc != VINF_SUCCESS)
+            {
+                Status = VBoxErrorToNTStatus(vrc);
                 vbsfFreeNonPagedMem(pHGCMBuffer);
                 break;
@@ -731,5 +731,5 @@
             uint32_t cbHGCMBuffer;
             uint8_t *pHGCMBuffer;
-            int vboxRC;
+            int vrc;
             PSHFLVOLINFO pShflVolInfo;
 
@@ -773,10 +773,10 @@
             }
 
-            vboxRC = VbglR0SfFsInfo(&pDeviceExtension->hgcmClient, &pNetRootExtension->map, pVBoxFobx->hFile,
-                                    SHFL_INFO_GET | SHFL_INFO_VOLUME, &cbHGCMBuffer, (PSHFLDIRINFO)pHGCMBuffer);
-
-            if (vboxRC != VINF_SUCCESS)
-            {
-                Status = VBoxErrorToNTStatus(vboxRC);
+            vrc = VbglR0SfFsInfo(&pDeviceExtension->hgcmClient, &pNetRootExtension->map, pVBoxFobx->hFile,
+                                 SHFL_INFO_GET | SHFL_INFO_VOLUME, &cbHGCMBuffer, (PSHFLDIRINFO)pHGCMBuffer);
+
+            if (vrc != VINF_SUCCESS)
+            {
+                Status = VBoxErrorToNTStatus(vrc);
                 vbsfFreeNonPagedMem(pHGCMBuffer);
                 break;
@@ -939,5 +939,5 @@
     ULONG *pLengthRemaining = (PULONG) & RxContext->Info.LengthRemaining;
 
-    int vboxRC = 0;
+    int vrc = 0;
 
     ULONG cbToCopy = 0;
@@ -1106,10 +1106,10 @@
 
         Assert(pVBoxFobx && pNetRootExtension && pDeviceExtension);
-        vboxRC = VbglR0SfFsInfo(&pDeviceExtension->hgcmClient, &pNetRootExtension->map, pVBoxFobx->hFile,
-                                SHFL_INFO_GET | SHFL_INFO_FILE, &cbHGCMBuffer, (PSHFLDIRINFO)pHGCMBuffer);
-
-        if (vboxRC != VINF_SUCCESS)
-        {
-            Status = VBoxErrorToNTStatus(vboxRC);
+        vrc = VbglR0SfFsInfo(&pDeviceExtension->hgcmClient, &pNetRootExtension->map, pVBoxFobx->hFile,
+                             SHFL_INFO_GET | SHFL_INFO_FILE, &cbHGCMBuffer, (PSHFLDIRINFO)pHGCMBuffer);
+
+        if (vrc != VINF_SUCCESS)
+        {
+            Status = VBoxErrorToNTStatus(vrc);
             goto end;
         }
@@ -1352,5 +1352,5 @@
     PVOID pInfoBuffer = (PVOID)RxContext->Info.Buffer;
 
-    int vboxRC;
+    int vrc;
 
     uint8_t *pHGCMBuffer = NULL;
@@ -1437,10 +1437,10 @@
 
             Assert(pVBoxFobx && pNetRootExtension && pDeviceExtension);
-            vboxRC = VbglR0SfFsInfo(&pDeviceExtension->hgcmClient, &pNetRootExtension->map, pVBoxFobx->hFile,
-                                    SHFL_INFO_SET | SHFL_INFO_FILE, &cbBuffer, (PSHFLDIRINFO)pSHFLFileInfo);
-
-            if (vboxRC != VINF_SUCCESS)
-            {
-                Status = VBoxErrorToNTStatus(vboxRC);
+            vrc = VbglR0SfFsInfo(&pDeviceExtension->hgcmClient, &pNetRootExtension->map, pVBoxFobx->hFile,
+                                 SHFL_INFO_SET | SHFL_INFO_FILE, &cbBuffer, (PSHFLDIRINFO)pSHFLFileInfo);
+
+            if (vrc != VINF_SUCCESS)
+            {
+                Status = VBoxErrorToNTStatus(vrc);
                 goto end;
             }
Index: trunk/src/VBox/Additions/WINNT/SharedFolders/driver/net.c
===================================================================
--- trunk/src/VBox/Additions/WINNT/SharedFolders/driver/net.c	(revision 78279)
+++ trunk/src/VBox/Additions/WINNT/SharedFolders/driver/net.c	(revision 78280)
@@ -166,5 +166,5 @@
         PWCHAR pRootName;
         ULONG RootNameLength;
-        int vboxRC;
+        int vrc;
         PSHFLSTRING ParsedPath = 0;
 
@@ -204,9 +204,9 @@
             }
 
-            vboxRC = VbglR0SfMapFolder(&pDeviceExtension->hgcmClient, ParsedPath, &pNetRootExtension->map);
+            vrc = VbglR0SfMapFolder(&pDeviceExtension->hgcmClient, ParsedPath, &pNetRootExtension->map);
             vbsfFreeNonPagedMem(ParsedPath);
-            if (vboxRC != VINF_SUCCESS)
+            if (vrc != VINF_SUCCESS)
             {
-                Log(("VBOXSF: MRxCreateVNetRoot: VbglR0SfMapFolder failed with %d\n", vboxRC));
+                Log(("VBOXSF: MRxCreateVNetRoot: VbglR0SfMapFolder failed with %d\n", vrc));
                 Status = STATUS_BAD_NETWORK_NAME;
             }
@@ -261,8 +261,8 @@
     if (pNetRootExtension->phgcmClient)
     {
-        int vboxRC = VbglR0SfUnmapFolder(pNetRootExtension->phgcmClient, &pNetRootExtension->map);
-        if (vboxRC != VINF_SUCCESS)
+        int vrc = VbglR0SfUnmapFolder(pNetRootExtension->phgcmClient, &pNetRootExtension->map);
+        if (vrc != VINF_SUCCESS)
             Log(("VBOXSF: MRxFinalizeVNetRoot: VbglR0SfUnmapFolder failed with %d\n",
-                 vboxRC));
+                 vrc));
         pNetRootExtension->phgcmClient = NULL;
     }
Index: trunk/src/VBox/Additions/WINNT/SharedFolders/driver/path.c
===================================================================
--- trunk/src/VBox/Additions/WINNT/SharedFolders/driver/path.c	(revision 78279)
+++ trunk/src/VBox/Additions/WINNT/SharedFolders/driver/path.c	(revision 78280)
@@ -38,5 +38,5 @@
     PMRX_VBOX_NETROOT_EXTENSION pNetRootExtension = VBoxMRxGetNetRootExtension(capFcb->pNetRoot);
 
-    int vboxRC = VINF_SUCCESS;
+    int vrc = VINF_SUCCESS;
 
     /* Various boolean flags. */
@@ -263,16 +263,16 @@
         /* Call host. */
         Log(("VBOXSF: vbsfProcessCreate: VbglR0SfCreate called.\n"));
-        vboxRC = VbglR0SfCreate(&pDeviceExtension->hgcmClient, &pNetRootExtension->map, ParsedPath, pCreateParms);
+        vrc = VbglR0SfCreate(&pDeviceExtension->hgcmClient, &pNetRootExtension->map, ParsedPath, pCreateParms);
 
         vbsfFreeNonPagedMem(ParsedPath);
     }
 
-    Log(("VBOXSF: vbsfProcessCreate: VbglR0SfCreate returns vboxRC = %Rrc, Result = 0x%x\n",
-         vboxRC, pCreateParms->Result));
-
-    if (RT_FAILURE(vboxRC))
+    Log(("VBOXSF: vbsfProcessCreate: VbglR0SfCreate returns vrc = %Rrc, Result = 0x%x\n",
+         vrc, pCreateParms->Result));
+
+    if (RT_FAILURE(vrc))
     {
         /* Map some VBoxRC to STATUS codes expected by the system. */
-        switch (vboxRC)
+        switch (vrc)
         {
             case VERR_ALREADY_EXISTS:
@@ -294,5 +294,5 @@
             {
                 *pulCreateAction = FILE_DOES_NOT_EXIST;
-                Status = VBoxErrorToNTStatus(vboxRC);
+                Status = VBoxErrorToNTStatus(vrc);
                 goto failure;
             }
@@ -663,5 +663,5 @@
     NTSTATUS Status = STATUS_SUCCESS;
 
-    int vboxRC;
+    int vrc;
     PSHFLFSOBJINFO pSHFLFileInfo;
 
@@ -704,9 +704,9 @@
         pSHFLFileInfo->Attr.fMode = NTToVBoxFileAttributes(pInfo->FileAttributes);
 
-    vboxRC = VbglR0SfFsInfo(&pDeviceExtension->hgcmClient, &pNetRootExtension->map, pVBoxFobx->hFile,
-                            SHFL_INFO_SET | SHFL_INFO_FILE, &cbBuffer, (PSHFLDIRINFO)pSHFLFileInfo);
-
-    if (vboxRC != VINF_SUCCESS)
-        Status = VBoxErrorToNTStatus(vboxRC);
+    vrc = VbglR0SfFsInfo(&pDeviceExtension->hgcmClient, &pNetRootExtension->map, pVBoxFobx->hFile,
+                         SHFL_INFO_SET | SHFL_INFO_FILE, &cbBuffer, (PSHFLDIRINFO)pSHFLFileInfo);
+
+    if (vrc != VINF_SUCCESS)
+        Status = VBoxErrorToNTStatus(vrc);
 
     if (pHGCMBuffer)
@@ -727,5 +727,5 @@
     NTSTATUS Status = STATUS_SUCCESS;
 
-    int vboxRC;
+    int vrc;
 
     if (pVBoxFobx->hFile == SHFL_HANDLE_NIL)
@@ -750,12 +750,12 @@
     }
 
-    vboxRC = VbglR0SfClose(&pDeviceExtension->hgcmClient,
-                           &pNetRootExtension->map,
-                           pVBoxFobx->hFile);
+    vrc = VbglR0SfClose(&pDeviceExtension->hgcmClient,
+                        &pNetRootExtension->map,
+                        pVBoxFobx->hFile);
 
     pVBoxFobx->hFile = SHFL_HANDLE_NIL;
 
-    if (vboxRC != VINF_SUCCESS)
-        Status = VBoxErrorToNTStatus(vboxRC);
+    if (vrc != VINF_SUCCESS)
+        Status = VBoxErrorToNTStatus(vrc);
 
     Log(("VBOXSF: vbsfCloseFileHandle: Returned 0x%08X\n", Status));
@@ -827,5 +827,5 @@
     PUNICODE_STRING RemainingName = GET_ALREADY_PREFIXED_NAME_FROM_CONTEXT(RxContext);
 
-    int vboxRC;
+    int vrc;
     PSHFLSTRING ParsedPath = NULL;
 
@@ -843,17 +843,17 @@
 
     /* Call host. */
-    vboxRC = VbglR0SfRemove(&pDeviceExtension->hgcmClient, &pNetRootExtension->map,
-                            ParsedPath,
-                            (pVBoxFobx->FileStandardInfo.Directory) ? SHFL_REMOVE_DIR : SHFL_REMOVE_FILE);
+    vrc = VbglR0SfRemove(&pDeviceExtension->hgcmClient, &pNetRootExtension->map,
+                         ParsedPath,
+                         (pVBoxFobx->FileStandardInfo.Directory) ? SHFL_REMOVE_DIR : SHFL_REMOVE_FILE);
 
     if (ParsedPath)
         vbsfFreeNonPagedMem(ParsedPath);
 
-    if (vboxRC == VINF_SUCCESS)
+    if (vrc == VINF_SUCCESS)
         SetFlag(capFobx->pSrvOpen->Flags, SRVOPEN_FLAG_FILE_DELETED);
 
-    Status = VBoxErrorToNTStatus(vboxRC);
-    if (vboxRC != VINF_SUCCESS)
-        Log(("VBOXSF: vbsfRemove: VbglR0SfRemove failed with %Rrc\n", vboxRC));
+    Status = VBoxErrorToNTStatus(vrc);
+    if (vrc != VINF_SUCCESS)
+        Log(("VBOXSF: vbsfRemove: VbglR0SfRemove failed with %Rrc\n", vrc));
 
     Log(("VBOXSF: vbsfRemove: Returned 0x%08X\n", Status));
@@ -879,5 +879,5 @@
     PUNICODE_STRING RemainingName = GET_ALREADY_PREFIXED_NAME(pSrvOpen, capFcb);
 
-    int vboxRC;
+    int vrc;
     PSHFLSTRING SrcPath = 0, DestPath = 0;
     ULONG flags;
@@ -922,12 +922,12 @@
 
     Log(("VBOXSF: vbsfRename: Calling VbglR0SfRename\n"));
-    vboxRC = VbglR0SfRename(&pDeviceExtension->hgcmClient, &pNetRootExtension->map, SrcPath, DestPath, flags);
+    vrc = VbglR0SfRename(&pDeviceExtension->hgcmClient, &pNetRootExtension->map, SrcPath, DestPath, flags);
 
     vbsfFreeNonPagedMem(SrcPath);
     vbsfFreeNonPagedMem(DestPath);
 
-    Status = VBoxErrorToNTStatus(vboxRC);
-    if (vboxRC != VINF_SUCCESS)
-        Log(("VBOXSF: vbsfRename: VbglR0SfRename failed with %Rrc\n", vboxRC));
+    Status = VBoxErrorToNTStatus(vrc);
+    if (vrc != VINF_SUCCESS)
+        Log(("VBOXSF: vbsfRename: VbglR0SfRename failed with %Rrc\n", vrc));
 
     Log(("VBOXSF: vbsfRename: Returned 0x%08X\n", Status));
Index: trunk/src/VBox/Additions/WINNT/SharedFolders/driver/vbsf.c
===================================================================
--- trunk/src/VBox/Additions/WINNT/SharedFolders/driver/vbsf.c	(revision 78279)
+++ trunk/src/VBox/Additions/WINNT/SharedFolders/driver/vbsf.c	(revision 78280)
@@ -406,5 +406,5 @@
     PMRX_VBOX_DEVICE_EXTENSION pDeviceExtension = NULL;
     ULONG i;
-    int vboxRC;
+    int vrc;
     VBGLSFCLIENT hgcmClient;
 
@@ -418,8 +418,8 @@
 
     /* Initialize VBox subsystem. */
-    vboxRC = VbglR0SfInit();
-    if (RT_FAILURE(vboxRC))
-    {
-        Log(("VBOXSF: DriverEntry: ERROR while initializing VBox subsystem (%Rrc)!\n", vboxRC));
+    vrc = VbglR0SfInit();
+    if (RT_FAILURE(vrc))
+    {
+        Log(("VBOXSF: DriverEntry: ERROR while initializing VBox subsystem (%Rrc)!\n", vrc));
         return STATUS_UNSUCCESSFUL;
     }
@@ -427,9 +427,9 @@
     /* Connect the HGCM client */
     RT_ZERO(hgcmClient);
-    vboxRC = VbglR0SfConnect(&hgcmClient);
-    if (RT_FAILURE(vboxRC))
+    vrc = VbglR0SfConnect(&hgcmClient);
+    if (RT_FAILURE(vrc))
     {
         Log(("VBOXSF: DriverEntry: ERROR while connecting to host (%Rrc)!\n",
-             vboxRC));
+             vrc));
         VbglR0SfTerm();
         return STATUS_UNSUCCESSFUL;
@@ -704,5 +704,5 @@
                     uint8_t *pu8Out = (uint8_t *)LowIoContext->ParamsFor.IoCtl.pOutputBuffer;
 
-                    int vboxRC;
+                    int vrc;
                     SHFLMAPPING mappings[_MRX_MAX_DRIVE_LETTERS];
                     uint32_t cMappings = RT_ELEMENTS(mappings);
@@ -719,6 +719,6 @@
                     }
 
-                    vboxRC = VbglR0SfQueryMappings(&pDeviceExtension->hgcmClient, mappings, &cMappings);
-                    if (vboxRC == VINF_SUCCESS)
+                    vrc = VbglR0SfQueryMappings(&pDeviceExtension->hgcmClient, mappings, &cMappings);
+                    if (vrc == VINF_SUCCESS)
                     {
                         __try
@@ -743,5 +743,5 @@
                     else
                     {
-                        Status = VBoxErrorToNTStatus(vboxRC);
+                        Status = VBoxErrorToNTStatus(vrc);
                         Log(("VBOXSF: MRxDevFcbXXXControlFile: IOCTL_MRX_VBOX_GETGLOBALLIST failed: 0x%08X\n",
                              Status));
@@ -846,5 +846,5 @@
                     PWCHAR pwcRemoteName = (PWCHAR)LowIoContext->ParamsFor.IoCtl.pOutputBuffer;
 
-                    int vboxRC;
+                    int vrc;
                     PSHFLSTRING pString;
 
@@ -870,8 +870,8 @@
                              *pu8ConnectId));
 
-                        vboxRC = VbglR0SfQueryMapName(&pDeviceExtension->hgcmClient,
-                                                      (*pu8ConnectId) & ~0x80 /** @todo fix properly */,
-                                                      pString, ShflStringSizeOfBuffer(pString));
-                        if (   vboxRC == VINF_SUCCESS
+                        vrc = VbglR0SfQueryMapName(&pDeviceExtension->hgcmClient,
+                                                   *pu8ConnectId & ~0x80 /** @todo fix properly */,
+                                                   pString, ShflStringSizeOfBuffer(pString));
+                        if (   vrc == VINF_SUCCESS
                             && pString->u16Length < cbRemoteName)
                         {
Index: trunk/src/VBox/Additions/WINNT/SharedFolders/driver/vbsfhlp.c
===================================================================
--- trunk/src/VBox/Additions/WINNT/SharedFolders/driver/vbsfhlp.c	(revision 78279)
+++ trunk/src/VBox/Additions/WINNT/SharedFolders/driver/vbsfhlp.c	(revision 78280)
@@ -104,12 +104,12 @@
  *
  * @returns NT status code
- * @param   vboxRC          VBox error code
- *
- */
-NTSTATUS VBoxErrorToNTStatus(int vboxRC)
+ * @param   vrc             VBox status code.
+ *
+ */
+NTSTATUS VBoxErrorToNTStatus(int vrc)
 {
     NTSTATUS Status;
 
-    switch (vboxRC)
+    switch (vrc)
     {
         case VINF_SUCCESS:
@@ -192,5 +192,5 @@
             Status = STATUS_INVALID_PARAMETER;
             Log(("Unexpected vbox error %Rrc\n",
-                 vboxRC));
+                 vrc));
             break;
     }
Index: trunk/src/VBox/Additions/WINNT/SharedFolders/driver/vbsfhlp.h
===================================================================
--- trunk/src/VBox/Additions/WINNT/SharedFolders/driver/vbsfhlp.h	(revision 78279)
+++ trunk/src/VBox/Additions/WINNT/SharedFolders/driver/vbsfhlp.h	(revision 78280)
@@ -34,13 +34,5 @@
 uint32_t VBoxToNTFileAttributes(uint32_t fIprtMode);
 uint32_t NTToVBoxFileAttributes(uint32_t fNtAttribs);
-
-/**
- * Convert VBox error code to NT status code
- *
- * @returns NT status code
- * @param   vboxRC          VBox error code
- *
- */
-NTSTATUS VBoxErrorToNTStatus(int vboxRC);
+NTSTATUS VBoxErrorToNTStatus(int vrc);
 
 PVOID    vbsfAllocNonPagedMem(ULONG ulSize);