Index: trunk/src/VBox/Additions/WINNT/VBoxTray/VBoxClipboard.cpp
===================================================================
--- trunk/src/VBox/Additions/WINNT/VBoxTray/VBoxClipboard.cpp	(revision 78314)
+++ trunk/src/VBox/Additions/WINNT/VBoxTray/VBoxClipboard.cpp	(revision 78315)
@@ -78,5 +78,5 @@
                int vboxrc = VBoxClipboardWinGetFormats(&pCtx->Win, &uFormats);
                if (RT_SUCCESS(vboxrc))
-                   vboxrc = VbglR3ClipboardWriteFormats(pCtx->u32ClientID, uFormats);
+                   vboxrc = VbglR3ClipboardReportFormats(pCtx->u32ClientID, uFormats);
            }
         }
@@ -128,5 +128,5 @@
                int vboxrc = VBoxClipboardWinGetFormats(pWinCtx, &uFormats);
                if (RT_SUCCESS(vboxrc))
-                   vboxrc = VbglR3ClipboardWriteFormats(pCtx->u32ClientID, uFormats);
+                   vboxrc = VbglR3ClipboardReportFormats(pCtx->u32ClientID, uFormats);
            }
 
Index: trunk/src/VBox/Additions/common/VBoxGuest/lib/VBoxGuestR3LibClipboard.cpp
===================================================================
--- trunk/src/VBox/Additions/common/VBoxGuest/lib/VBoxGuestR3LibClipboard.cpp	(revision 78314)
+++ trunk/src/VBox/Additions/common/VBoxGuest/lib/VBoxGuestR3LibClipboard.cpp	(revision 78315)
@@ -154,5 +154,5 @@
 
 /**
- * Writes (advertises) guest clipboard formats to the host.
+ * Reports (advertises) guest clipboard formats to the host.
  *
  * @returns VBox status code.
@@ -160,9 +160,9 @@
  * @param   fFormats        The formats to advertise.
  */
-VBGLR3DECL(int) VbglR3ClipboardWriteFormats(HGCMCLIENTID idClient, uint32_t fFormats)
+VBGLR3DECL(int) VbglR3ClipboardReportFormats(HGCMCLIENTID idClient, uint32_t fFormats)
 {
     VBoxClipboardWriteFormats Msg;
 
-    VBGL_HGCM_HDR_INIT(&Msg.hdr, idClient, VBOX_SHARED_CLIPBOARD_FN_WRITE_FORMATS, 1);
+    VBGL_HGCM_HDR_INIT(&Msg.hdr, idClient, VBOX_SHARED_CLIPBOARD_FN_REPORT_FORMATS, 1);
     VbglHGCMParmUInt32Set(&Msg.formats, fFormats);
 
Index: trunk/src/VBox/Additions/common/VBoxService/VBoxServiceClipboard-os2.cpp
===================================================================
--- trunk/src/VBox/Additions/common/VBoxService/VBoxServiceClipboard-os2.cpp	(revision 78314)
+++ trunk/src/VBox/Additions/common/VBoxService/VBoxServiceClipboard-os2.cpp	(revision 78315)
@@ -611,5 +611,5 @@
     }
     VGSvcVerbose(4, "clipboard: reporting fFormats=%#x\n", fFormats);
-    VbglR3ClipboardWriteFormats(g_u32ClientId, fFormats);
+    VbglR3ClipboardReportFormats(g_u32ClientId, fFormats);
 }
 
@@ -658,5 +658,5 @@
                 g_fEmptyClipboard = true;
                 VGSvcVerbose(3, "Reporting empty clipboard\n");
-                VbglR3ClipboardWriteFormats(g_u32ClientId, 0);
+                VbglR3ClipboardReportFormats(g_u32ClientId, 0);
             }
         }
@@ -681,5 +681,5 @@
     g_fEmptyClipboard = true;
     VGSvcVerbose(3, "Reporting empty clipboard\n");
-    VbglR3ClipboardWriteFormats(g_u32ClientId, 0);
+    VbglR3ClipboardReportFormats(g_u32ClientId, 0);
 
     vgsvcClipboardOs2PollViewer();
Index: trunk/src/VBox/Additions/haiku/VBoxTray/VBoxClipboard.cpp
===================================================================
--- trunk/src/VBox/Additions/haiku/VBoxTray/VBoxClipboard.cpp	(revision 78314)
+++ trunk/src/VBox/Additions/haiku/VBoxTray/VBoxClipboard.cpp	(revision 78315)
@@ -345,5 +345,5 @@
             be_clipboard->Unlock();
 
-            VbglR3ClipboardWriteFormats(fClientId, formats);
+            VbglR3ClipboardReportFormats(fClientId, formats);
             break;
         }
Index: trunk/src/VBox/Additions/x11/VBoxClient/clipboard.cpp
===================================================================
--- trunk/src/VBox/Additions/x11/VBoxClient/clipboard.cpp	(revision 78314)
+++ trunk/src/VBox/Additions/x11/VBoxClient/clipboard.cpp	(revision 78315)
@@ -152,5 +152,5 @@
     RT_NOREF1(pCtx);
     LogRelFlowFunc(("u32Formats=%d\n", u32Formats));
-    int rc = VbglR3ClipboardWriteFormats(g_ctx.client, u32Formats);
+    int rc = VbglR3ClipboardReportFormats(g_ctx.client, u32Formats);
     LogRelFlowFunc(("rc=%Rrc\n", rc));
 }