Index: trunk/src/VBox/Additions/WINNT/SharedFolders/driver/file.cpp
===================================================================
--- trunk/src/VBox/Additions/WINNT/SharedFolders/driver/file.cpp	(revision 78320)
+++ trunk/src/VBox/Additions/WINNT/SharedFolders/driver/file.cpp	(revision 78321)
@@ -16,4 +16,7 @@
  */
 
+/*********************************************************************************************************************************
+*   Header Files                                                                                                                 *
+*********************************************************************************************************************************/
 #include "vbsf.h"
 #include <iprt/fs.h>
@@ -21,4 +24,7 @@
 
 
+/*********************************************************************************************************************************
+*   Defined Constants And Macros                                                                                                 *
+*********************************************************************************************************************************/
 /* How much data to transfer in one HGCM request. */
 #define VBSF_MAX_READ_WRITE_PAGES 256
Index: trunk/src/VBox/Additions/WINNT/SharedFolders/driver/info.cpp
===================================================================
--- trunk/src/VBox/Additions/WINNT/SharedFolders/driver/info.cpp	(revision 78320)
+++ trunk/src/VBox/Additions/WINNT/SharedFolders/driver/info.cpp	(revision 78321)
@@ -16,8 +16,15 @@
  */
 
+
+/*********************************************************************************************************************************
+*   Header Files                                                                                                                 *
+*********************************************************************************************************************************/
 #include "vbsf.h"
 #include <iprt/err.h>
 
 
+/*********************************************************************************************************************************
+*   Defined Constants And Macros                                                                                                 *
+*********************************************************************************************************************************/
 /** Macro for copying a SHFLSTRING file name into a FILE_DIRECTORY_INFORMATION structure. */
 #define INIT_FILE_NAME(obj, str) \
@@ -27,4 +34,5 @@
         RtlCopyMemory((obj)->FileName, &(str).String.ucs2[0], cbLength + 2); \
     } while (0)
+
 
 NTSTATUS VBoxMRxQueryDirectory(IN OUT PRX_CONTEXT RxContext)
Index: trunk/src/VBox/Additions/WINNT/SharedFolders/driver/net.cpp
===================================================================
--- trunk/src/VBox/Additions/WINNT/SharedFolders/driver/net.cpp	(revision 78320)
+++ trunk/src/VBox/Additions/WINNT/SharedFolders/driver/net.cpp	(revision 78321)
@@ -16,5 +16,10 @@
  */
 
+
+/*********************************************************************************************************************************
+*   Header Files                                                                                                                 *
+*********************************************************************************************************************************/
 #include "vbsf.h"
+
 
 NTSTATUS VBoxMRxUpdateNetRootState(IN OUT PMRX_NET_ROOT pNetRoot)
Index: trunk/src/VBox/Additions/WINNT/SharedFolders/driver/path.cpp
===================================================================
--- trunk/src/VBox/Additions/WINNT/SharedFolders/driver/path.cpp	(revision 78320)
+++ trunk/src/VBox/Additions/WINNT/SharedFolders/driver/path.cpp	(revision 78321)
@@ -16,9 +16,16 @@
  */
 
+/*********************************************************************************************************************************
+*   Header Files                                                                                                                 *
+*********************************************************************************************************************************/
 #include "vbsf.h"
 #include <iprt/err.h>
 
 
+/*********************************************************************************************************************************
+*   Defined Constants And Macros                                                                                                 *
+*********************************************************************************************************************************/
 static UNICODE_STRING g_UnicodeBackslash = { 2, 4, L"\\" };
+
 
 static NTSTATUS vbsfProcessCreate(PRX_CONTEXT RxContext,
Index: trunk/src/VBox/Additions/WINNT/SharedFolders/driver/vbsf.cpp
===================================================================
--- trunk/src/VBox/Additions/WINNT/SharedFolders/driver/vbsf.cpp	(revision 78320)
+++ trunk/src/VBox/Additions/WINNT/SharedFolders/driver/vbsf.cpp	(revision 78321)
@@ -16,7 +16,14 @@
  */
 
+
+/*********************************************************************************************************************************
+*   Header Files                                                                                                                 *
+*********************************************************************************************************************************/
 #include "vbsf.h"
 
 
+/*********************************************************************************************************************************
+*   Structures and Typedefs                                                                                                      *
+*********************************************************************************************************************************/
 /**
  * The current state of the driver.
Index: trunk/src/VBox/Additions/WINNT/SharedFolders/driver/vbsf.h
===================================================================
--- trunk/src/VBox/Additions/WINNT/SharedFolders/driver/vbsf.h	(revision 78320)
+++ trunk/src/VBox/Additions/WINNT/SharedFolders/driver/vbsf.h	(revision 78321)
@@ -22,9 +22,10 @@
 #endif
 
+
 /*
  * This must be defined before including RX headers.
  */
-#define MINIRDR__NAME VBoxMRx
-#define ___MINIRDR_IMPORTS_NAME (VBoxMRxDeviceObject->RdbssExports)
+#define MINIRDR__NAME               VBoxMRx
+#define ___MINIRDR_IMPORTS_NAME     (VBoxMRxDeviceObject->RdbssExports)
 
 /*
@@ -41,28 +42,31 @@
  * VBox shared folders.
  */
-#include "vbsfhlp.h"
 #include "vbsfshared.h"
-#ifdef __cplusplus /* mixes code and variables */
-# include <VBox/VBoxGuestLibSharedFoldersInline.h>
-#endif
+#include <VBox/log.h>
+#include <VBox/VBoxGuestLibSharedFolders.h>
+#include <VBox/VBoxGuestLibSharedFoldersInline.h>
+
 
 RT_C_DECLS_BEGIN
 
+/*
+ * Global data.
+ */
 extern PRDBSS_DEVICE_OBJECT VBoxMRxDeviceObject;
 
-/*
+/**
  * Maximum drive letters (A - Z).
  */
 #define _MRX_MAX_DRIVE_LETTERS 26
 
-/*
+/**
  * The shared folders device extension.
  */
 typedef struct _MRX_VBOX_DEVICE_EXTENSION
 {
-    /* The shared folders device object pointer. */
+    /** The shared folders device object pointer. */
     PRDBSS_DEVICE_OBJECT pDeviceObject;
 
-    /*
+    /**
      * Keep a list of local connections used.
      * The size (_MRX_MAX_DRIVE_LETTERS = 26) of the array presents the available drive letters C: - Z: of Windows.
@@ -79,10 +83,10 @@
 } MRX_VBOX_DEVICE_EXTENSION, *PMRX_VBOX_DEVICE_EXTENSION;
 
-/*
+/**
  * The shared folders NET_ROOT extension.
  */
 typedef struct _MRX_VBOX_NETROOT_EXTENSION
 {
-    /* The shared folder map handle of this netroot. */
+    /** The shared folder map handle of this netroot. */
     VBGLSFMAP map;
     /** Simple initialized (mapped folder) indicator that works better with the
@@ -137,6 +141,6 @@
 #define VBOX_MJ_CREATE_SLASH_HACK   UINT16_C(0x0400)
 
-/*
- * Prototypes for the dispatch table routines.
+/** @name Prototypes for the dispatch table routines.
+ * @{
  */
 NTSTATUS VBoxMRxStart(IN OUT struct _RX_CONTEXT * RxContext,
@@ -190,8 +194,8 @@
                                 IN PBOOLEAN ForceDisconnect);
 NTSTATUS VBoxMRxUpdateNetRootState(IN PMRX_NET_ROOT pNetRoot);
-VOID VBoxMRxExtractNetRootName(IN PUNICODE_STRING FilePathName,
-                               IN PMRX_SRV_CALL SrvCall,
-                               OUT PUNICODE_STRING NetRootName,
-                               OUT PUNICODE_STRING RestOfName OPTIONAL);
+VOID     VBoxMRxExtractNetRootName(IN PUNICODE_STRING FilePathName,
+                                   IN PMRX_SRV_CALL SrvCall,
+                                   OUT PUNICODE_STRING NetRootName,
+                                   OUT PUNICODE_STRING RestOfName OPTIONAL);
 
 NTSTATUS VBoxMRxCreateSrvCall(PMRX_SRV_CALL pSrvCall,
@@ -204,7 +208,8 @@
 
 NTSTATUS VBoxMRxDevFcbXXXControlFile(IN OUT PRX_CONTEXT RxContext);
-
-/*
- * Support functions.
+/** @} */
+
+/** @name Support functions and helpers
+ * @{
  */
 NTSTATUS vbsfDeleteConnection(IN PRX_CONTEXT RxContext,
@@ -225,4 +230,62 @@
 
 
+
+NTSTATUS vbsfHlpCreateDriveLetter(WCHAR Letter, UNICODE_STRING *pDeviceName);
+NTSTATUS vbsfHlpDeleteDriveLetter(WCHAR Letter);
+NTSTATUS VBoxErrorToNTStatus(int vrc);
+
+PVOID    vbsfAllocNonPagedMem(ULONG ulSize);
+void     vbsfFreeNonPagedMem(PVOID lpMem);
+
+#if defined(DEBUG) || defined(LOG_ENABLED)
+PCHAR MajorFunctionString(UCHAR MajorFunction, LONG MinorFunction);
+#endif
+
+NTSTATUS vbsfShflStringFromUnicodeAlloc(PSHFLSTRING *ppShflString, const WCHAR *pwc, uint16_t cb);
+
+/**
+ * Converts VBox (IPRT) file mode to NT file attributes.
+ *
+ * @returns NT file attributes
+ * @param   fIprtMode   IPRT file mode.
+ *
+ */
+DECLINLINE(uint32_t) VBoxToNTFileAttributes(uint32_t fIprtMode)
+{
+    AssertCompile((RTFS_DOS_READONLY               >> RTFS_DOS_SHIFT) == FILE_ATTRIBUTE_READONLY);
+    AssertCompile((RTFS_DOS_HIDDEN                 >> RTFS_DOS_SHIFT) == FILE_ATTRIBUTE_HIDDEN);
+    AssertCompile((RTFS_DOS_SYSTEM                 >> RTFS_DOS_SHIFT) == FILE_ATTRIBUTE_SYSTEM);
+    AssertCompile((RTFS_DOS_DIRECTORY              >> RTFS_DOS_SHIFT) == FILE_ATTRIBUTE_DIRECTORY);
+    AssertCompile((RTFS_DOS_ARCHIVED               >> RTFS_DOS_SHIFT) == FILE_ATTRIBUTE_ARCHIVE);
+    AssertCompile((RTFS_DOS_NT_DEVICE              >> RTFS_DOS_SHIFT) == FILE_ATTRIBUTE_DEVICE);
+    AssertCompile((RTFS_DOS_NT_NORMAL              >> RTFS_DOS_SHIFT) == FILE_ATTRIBUTE_NORMAL);
+    AssertCompile((RTFS_DOS_NT_TEMPORARY           >> RTFS_DOS_SHIFT) == FILE_ATTRIBUTE_TEMPORARY);
+    AssertCompile((RTFS_DOS_NT_SPARSE_FILE         >> RTFS_DOS_SHIFT) == FILE_ATTRIBUTE_SPARSE_FILE);
+    AssertCompile((RTFS_DOS_NT_REPARSE_POINT       >> RTFS_DOS_SHIFT) == FILE_ATTRIBUTE_REPARSE_POINT);
+    AssertCompile((RTFS_DOS_NT_COMPRESSED          >> RTFS_DOS_SHIFT) == FILE_ATTRIBUTE_COMPRESSED);
+    AssertCompile((RTFS_DOS_NT_OFFLINE             >> RTFS_DOS_SHIFT) == FILE_ATTRIBUTE_OFFLINE);
+    AssertCompile((RTFS_DOS_NT_NOT_CONTENT_INDEXED >> RTFS_DOS_SHIFT) == FILE_ATTRIBUTE_NOT_CONTENT_INDEXED);
+    AssertCompile((RTFS_DOS_NT_ENCRYPTED           >> RTFS_DOS_SHIFT) == FILE_ATTRIBUTE_ENCRYPTED);
+
+    uint32_t fNtAttribs = (fIprtMode & (RTFS_DOS_MASK_NT & ~(RTFS_DOS_NT_OFFLINE | RTFS_DOS_NT_DEVICE | RTFS_DOS_NT_REPARSE_POINT)))
+                       >> RTFS_DOS_SHIFT;
+    return fNtAttribs ? fNtAttribs : FILE_ATTRIBUTE_NORMAL;
+}
+
+/**
+ * Converts NT file attributes to VBox (IPRT) ones.
+ *
+ * @returns IPRT file mode
+ * @param   fNtAttribs      NT file attributes
+ */
+DECLINLINE(uint32_t) NTToVBoxFileAttributes(uint32_t fNtAttribs)
+{
+    uint32_t fIprtMode = (fNtAttribs << RTFS_DOS_SHIFT) & RTFS_DOS_MASK_NT;
+    fIprtMode &= ~(RTFS_DOS_NT_OFFLINE | RTFS_DOS_NT_DEVICE | RTFS_DOS_NT_REPARSE_POINT);
+    return fIprtMode ? fIprtMode : RTFS_DOS_NT_NORMAL;
+}
+
+/** @} */
+
 RT_C_DECLS_END
 
Index: trunk/src/VBox/Additions/WINNT/SharedFolders/driver/vbsfhlp.cpp
===================================================================
--- trunk/src/VBox/Additions/WINNT/SharedFolders/driver/vbsfhlp.cpp	(revision 78320)
+++ trunk/src/VBox/Additions/WINNT/SharedFolders/driver/vbsfhlp.cpp	(revision 78321)
@@ -16,67 +16,19 @@
  */
 
-#include <iprt/nt/nt.h> /* includes ntifs.h and wdm.h */
-#include <iprt/win/ntdddisk.h>
-
-#include "vbsfhlp.h"
+
+/*********************************************************************************************************************************
+*   Header Files                                                                                                                 *
+*********************************************************************************************************************************/
+#include "vbsf.h"
 #include <iprt/err.h>
 
+
+/*********************************************************************************************************************************
+*   Global Variables                                                                                                             *
+*********************************************************************************************************************************/
 #ifdef DEBUG
 static int s_iAllocRefCount = 0;
 #endif
 
-void vbsfHlpSleep(ULONG ulMillies)
-{
-    KEVENT event;
-    LARGE_INTEGER dueTime;
-
-    KeInitializeEvent(&event, NotificationEvent, FALSE);
-
-    dueTime.QuadPart = -10000 * (int)ulMillies;
-
-    KeWaitForSingleObject(&event, Executive, KernelMode, FALSE, &dueTime);
-}
-
-/**
- * Converts VBox (IPRT) file mode to NT file attributes.
- *
- * @returns NT file attributes
- * @param   fIprtMode   IPRT file mode.
- *
- */
-uint32_t VBoxToNTFileAttributes(uint32_t fIprtMode)
-{
-    AssertCompile((RTFS_DOS_READONLY               >> RTFS_DOS_SHIFT) == FILE_ATTRIBUTE_READONLY);
-    AssertCompile((RTFS_DOS_HIDDEN                 >> RTFS_DOS_SHIFT) == FILE_ATTRIBUTE_HIDDEN);
-    AssertCompile((RTFS_DOS_SYSTEM                 >> RTFS_DOS_SHIFT) == FILE_ATTRIBUTE_SYSTEM);
-    AssertCompile((RTFS_DOS_DIRECTORY              >> RTFS_DOS_SHIFT) == FILE_ATTRIBUTE_DIRECTORY);
-    AssertCompile((RTFS_DOS_ARCHIVED               >> RTFS_DOS_SHIFT) == FILE_ATTRIBUTE_ARCHIVE);
-    /* skipping:   RTFS_DOS_NT_DEVICE */
-    AssertCompile((RTFS_DOS_NT_NORMAL              >> RTFS_DOS_SHIFT) == FILE_ATTRIBUTE_NORMAL);
-    AssertCompile((RTFS_DOS_NT_TEMPORARY           >> RTFS_DOS_SHIFT) == FILE_ATTRIBUTE_TEMPORARY);
-    AssertCompile((RTFS_DOS_NT_SPARSE_FILE         >> RTFS_DOS_SHIFT) == FILE_ATTRIBUTE_SPARSE_FILE);
-    AssertCompile((RTFS_DOS_NT_REPARSE_POINT       >> RTFS_DOS_SHIFT) == FILE_ATTRIBUTE_REPARSE_POINT);
-    AssertCompile((RTFS_DOS_NT_COMPRESSED          >> RTFS_DOS_SHIFT) == FILE_ATTRIBUTE_COMPRESSED);
-    /* skipping:   RTFS_DOS_NT_OFFLINE */
-    AssertCompile((RTFS_DOS_NT_NOT_CONTENT_INDEXED >> RTFS_DOS_SHIFT) == FILE_ATTRIBUTE_NOT_CONTENT_INDEXED);
-    AssertCompile((RTFS_DOS_NT_ENCRYPTED           >> RTFS_DOS_SHIFT) == FILE_ATTRIBUTE_ENCRYPTED);
-
-    uint32_t fNtAttribs = (fIprtMode & (RTFS_DOS_MASK_NT & ~(RTFS_DOS_NT_OFFLINE | RTFS_DOS_NT_DEVICE | RTFS_DOS_NT_REPARSE_POINT)))
-                       >> RTFS_DOS_SHIFT;
-    return fNtAttribs ? fNtAttribs : FILE_ATTRIBUTE_NORMAL;
-}
-
-/**
- * Converts NT file attributes to VBox (IPRT) ones.
- *
- * @returns IPRT file mode
- * @param   fNtAttribs      NT file attributes
- */
-uint32_t NTToVBoxFileAttributes(uint32_t fNtAttribs)
-{
-    uint32_t fIprtMode = (fNtAttribs << RTFS_DOS_SHIFT) & RTFS_DOS_MASK_NT;
-    fIprtMode &= ~(RTFS_DOS_NT_OFFLINE | RTFS_DOS_NT_DEVICE | RTFS_DOS_NT_REPARSE_POINT);
-    return fIprtMode ? fIprtMode : RTFS_DOS_NT_NORMAL;
-}
 
 NTSTATUS vbsfHlpCreateDriveLetter(WCHAR Letter, UNICODE_STRING *pDeviceName)
Index: trunk/src/VBox/Additions/WINNT/SharedFolders/driver/vbsfhlp.h
===================================================================
--- trunk/src/VBox/Additions/WINNT/SharedFolders/driver/vbsfhlp.h	(revision 78320)
+++ 	(revision )
@@ -1,51 +1,0 @@
-/* $Id$ */
-/** @file
- * VirtualBox Windows Guest Shared Folders - File System Driver helpers
- */
-
-/*
- * Copyright (C) 2012-2019 Oracle Corporation
- *
- * This file is part of VirtualBox Open Source Edition (OSE), as
- * available from http://www.virtualbox.org. This file is free software;
- * you can redistribute it and/or modify it under the terms of the GNU
- * General Public License (GPL) as published by the Free Software
- * Foundation, in version 2 as it comes in the "COPYING" file of the
- * VirtualBox OSE distribution. VirtualBox OSE is distributed in the
- * hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
- */
-
-#ifndef GA_INCLUDED_SRC_WINNT_SharedFolders_driver_vbsfhlp_h
-#define GA_INCLUDED_SRC_WINNT_SharedFolders_driver_vbsfhlp_h
-#ifndef RT_WITHOUT_PRAGMA_ONCE
-# pragma once
-#endif
-
-#include <iprt/nt/nt.h> /* includes ntifs.h and wdm.h */
-#include <iprt/win/ntverp.h>
-
-#include <VBox/log.h>
-#include <VBox/VBoxGuestLibSharedFolders.h>
-
-RT_C_DECLS_BEGIN
-
-void     vbsfHlpSleep(ULONG ulMillies);
-NTSTATUS vbsfHlpCreateDriveLetter(WCHAR Letter, UNICODE_STRING *pDeviceName);
-NTSTATUS vbsfHlpDeleteDriveLetter(WCHAR Letter);
-uint32_t VBoxToNTFileAttributes(uint32_t fIprtMode);
-uint32_t NTToVBoxFileAttributes(uint32_t fNtAttribs);
-NTSTATUS VBoxErrorToNTStatus(int vrc);
-
-PVOID    vbsfAllocNonPagedMem(ULONG ulSize);
-void     vbsfFreeNonPagedMem(PVOID lpMem);
-
-#if defined(DEBUG) || defined(LOG_ENABLED)
-PCHAR MajorFunctionString(UCHAR MajorFunction, LONG MinorFunction);
-#endif
-
-NTSTATUS vbsfShflStringFromUnicodeAlloc(PSHFLSTRING *ppShflString, const WCHAR *pwc, uint16_t cb);
-
-RT_C_DECLS_END
-
-#endif /* !GA_INCLUDED_SRC_WINNT_SharedFolders_driver_vbsfhlp_h */
-
Index: trunk/src/VBox/Additions/WINNT/SharedFolders/driver/vbsfshared.h
===================================================================
--- trunk/src/VBox/Additions/WINNT/SharedFolders/driver/vbsfshared.h	(revision 78320)
+++ trunk/src/VBox/Additions/WINNT/SharedFolders/driver/vbsfshared.h	(revision 78321)
@@ -1,8 +1,5 @@
 /* $Id$ */
 /** @file
- *
- * VirtualBox Windows Guest Shared Folders
- *
- * File System Driver header file shared with the network provider dll
+ * VirtualBox Windows Guest Shared Folders FSD - Definitions shared with the network provider dll.
  */
 
@@ -25,34 +22,36 @@
 #endif
 
-/* The network provider name for shared folders. */
-#define MRX_VBOX_PROVIDER_NAME_U L"VirtualBox Shared Folders"
+/** The network provider name for shared folders. */
+#define MRX_VBOX_PROVIDER_NAME_U                L"VirtualBox Shared Folders"
 
-/* The filesystem name for shared folders. */
-#define MRX_VBOX_FILESYS_NAME_U L"VBoxSharedFolderFS"
+/** The filesystem name for shared folders. */
+#define MRX_VBOX_FILESYS_NAME_U                 L"VBoxSharedFolderFS"
 
-/* The redirector device name. */
-#define DD_MRX_VBOX_FS_DEVICE_NAME_U L"\\Device\\VBoxMiniRdr"
+/** The redirector device name. */
+#define DD_MRX_VBOX_FS_DEVICE_NAME_U            L"\\Device\\VBoxMiniRdr"
 
-#define VBOX_VOLNAME_PREFIX     L"VBOX_"
-#define VBOX_VOLNAME_PREFIX_SIZE  (sizeof(VBOX_VOLNAME_PREFIX) - sizeof(VBOX_VOLNAME_PREFIX[0]))
+/** Volume label prefix. */
+#define VBOX_VOLNAME_PREFIX                     L"VBOX_"
+/** Size of volume label prefix. */
+#define VBOX_VOLNAME_PREFIX_SIZE                (sizeof(VBOX_VOLNAME_PREFIX) - sizeof(VBOX_VOLNAME_PREFIX[0]))
 
-/* Name of symbolic link, which is used by the user mode dll to open the driver. */
-#define DD_MRX_VBOX_USERMODE_SHADOW_DEV_NAME_U     L"\\??\\VBoxMiniRdrDN"
-#define DD_MRX_VBOX_USERMODE_DEV_NAME_U            L"\\\\.\\VBoxMiniRdrDN"
+/** NT path of the symbolic link, which is used by the user mode dll to
+ * open the FSD. */
+#define DD_MRX_VBOX_USERMODE_SHADOW_DEV_NAME_U  L"\\??\\VBoxMiniRdrDN"
+/** Win32 path of the symbolic link, which is used by the user mode dll
+ * to open the FSD. */
+#define DD_MRX_VBOX_USERMODE_DEV_NAME_U         L"\\\\.\\VBoxMiniRdrDN"
 
-#define IOCTL_MRX_VBOX_BASE FILE_DEVICE_NETWORK_FILE_SYSTEM
-
-#define _MRX_VBOX_CONTROL_CODE(request, method, access) \
-                CTL_CODE(IOCTL_MRX_VBOX_BASE, request, method, access)
-
-/* VBoxSF IOCTL codes. */
-#define IOCTL_MRX_VBOX_ADDCONN       _MRX_VBOX_CONTROL_CODE(100, METHOD_BUFFERED, FILE_ANY_ACCESS)
-#define IOCTL_MRX_VBOX_GETCONN       _MRX_VBOX_CONTROL_CODE(101, METHOD_BUFFERED, FILE_ANY_ACCESS)
-#define IOCTL_MRX_VBOX_DELCONN       _MRX_VBOX_CONTROL_CODE(102, METHOD_BUFFERED, FILE_ANY_ACCESS)
-#define IOCTL_MRX_VBOX_GETLIST       _MRX_VBOX_CONTROL_CODE(103, METHOD_BUFFERED, FILE_ANY_ACCESS)
-#define IOCTL_MRX_VBOX_GETGLOBALLIST _MRX_VBOX_CONTROL_CODE(104, METHOD_BUFFERED, FILE_ANY_ACCESS)
-#define IOCTL_MRX_VBOX_GETGLOBALCONN _MRX_VBOX_CONTROL_CODE(105, METHOD_BUFFERED, FILE_ANY_ACCESS)
-#define IOCTL_MRX_VBOX_START         _MRX_VBOX_CONTROL_CODE(106, METHOD_BUFFERED, FILE_ANY_ACCESS)
-#define IOCTL_MRX_VBOX_STOP          _MRX_VBOX_CONTROL_CODE(107, METHOD_BUFFERED, FILE_ANY_ACCESS)
+/** @name IOCTL_MRX_VBOX_XXX - VBoxSF IOCTL codes.
+ * @{  */
+#define IOCTL_MRX_VBOX_ADDCONN          CTL_CODE(FILE_DEVICE_NETWORK_FILE_SYSTEM, 100, METHOD_BUFFERED, FILE_ANY_ACCESS)
+#define IOCTL_MRX_VBOX_GETCONN          CTL_CODE(FILE_DEVICE_NETWORK_FILE_SYSTEM, 101, METHOD_BUFFERED, FILE_ANY_ACCESS)
+#define IOCTL_MRX_VBOX_DELCONN          CTL_CODE(FILE_DEVICE_NETWORK_FILE_SYSTEM, 102, METHOD_BUFFERED, FILE_ANY_ACCESS)
+#define IOCTL_MRX_VBOX_GETLIST          CTL_CODE(FILE_DEVICE_NETWORK_FILE_SYSTEM, 103, METHOD_BUFFERED, FILE_ANY_ACCESS)
+#define IOCTL_MRX_VBOX_GETGLOBALLIST    CTL_CODE(FILE_DEVICE_NETWORK_FILE_SYSTEM, 104, METHOD_BUFFERED, FILE_ANY_ACCESS)
+#define IOCTL_MRX_VBOX_GETGLOBALCONN    CTL_CODE(FILE_DEVICE_NETWORK_FILE_SYSTEM, 105, METHOD_BUFFERED, FILE_ANY_ACCESS)
+#define IOCTL_MRX_VBOX_START            CTL_CODE(FILE_DEVICE_NETWORK_FILE_SYSTEM, 106, METHOD_BUFFERED, FILE_ANY_ACCESS)
+#define IOCTL_MRX_VBOX_STOP             CTL_CODE(FILE_DEVICE_NETWORK_FILE_SYSTEM, 107, METHOD_BUFFERED, FILE_ANY_ACCESS)
+/** @} */
 
 #endif /* !GA_INCLUDED_SRC_WINNT_SharedFolders_driver_vbsfshared_h */