Index: trunk/src/VBox/GuestHost/OpenGL/util/hash.c
===================================================================
--- trunk/src/VBox/GuestHost/OpenGL/util/hash.c	(revision 78263)
+++ trunk/src/VBox/GuestHost/OpenGL/util/hash.c	(revision 78341)
@@ -37,10 +37,8 @@
 
 struct CRHashTable {
-        unsigned int num_elements;
-        CRHashNode *buckets[CR_NUM_BUCKETS];
-        CRHashIdPool   *idPool;
-#ifdef CHROMIUM_THREADSAFE
+    unsigned int num_elements;
+    CRHashNode *buckets[CR_NUM_BUCKETS];
+    CRHashIdPool   *idPool;
     CRmutex mutex;
-#endif
 };
 
@@ -382,7 +380,5 @@
     }
     hash->idPool = crAllocHashIdPoolEx( min, max );
-#ifdef CHROMIUM_THREADSAFE
     crInitMutex(&hash->mutex);
-#endif
     return hash;
 }
@@ -400,8 +396,5 @@
     if ( !hash) return;
 
-#ifdef CHROMIUM_THREADSAFE
     crLockMutex(&hash->mutex);
-#endif
-
     for ( i = 0; i < CR_NUM_BUCKETS; i++ )
     {
@@ -424,10 +417,6 @@
     }
     crFreeHashIdPool( hash->idPool );
-
-#ifdef CHROMIUM_THREADSAFE
     crUnlockMutex(&hash->mutex);
     crFreeMutex(&hash->mutex);
-#endif
-
     crFree( hash );
 }
@@ -440,8 +429,5 @@
     if (!hash) return;
 
-#ifdef CHROMIUM_THREADSAFE
     crLockMutex(&hash->mutex);
-#endif
-
     for (i = 0; i < CR_NUM_BUCKETS; i++)
     {
@@ -465,9 +451,6 @@
     crFreeHashIdPool(hash->idPool);
 
-#ifdef CHROMIUM_THREADSAFE
     crUnlockMutex(&hash->mutex);
     crFreeMutex(&hash->mutex);
-#endif
-
     crFree(hash);
 }
@@ -476,14 +459,10 @@
 void crHashtableLock(CRHashTable *h)
 {
-#ifdef CHROMIUM_THREADSAFE
-    crLockMutex(&h->mutex);
-#endif
+    crLockMutex(&h->mutex);
 }
 
 void crHashtableUnlock(CRHashTable *h)
 {
-#ifdef CHROMIUM_THREADSAFE
-    crUnlockMutex(&h->mutex);
-#endif
+    crUnlockMutex(&h->mutex);
 }
 
@@ -513,11 +492,7 @@
         return;
 
-#ifdef CHROMIUM_THREADSAFE
     crLockMutex(&hash->mutex);
-#endif
     crHashtableWalkUnlocked(hash, walkFunc , dataPtr2);
-#ifdef CHROMIUM_THREADSAFE
     crUnlockMutex(&hash->mutex);
-#endif
 }
 
@@ -531,7 +506,6 @@
     unsigned int index = crHash(key);
     CRHashNode *node = (CRHashNode *) crCalloc( sizeof( CRHashNode ) );
-#ifdef CHROMIUM_THREADSAFE
-    crLockMutex(&h->mutex);
-#endif
+
+    crLockMutex(&h->mutex);
     node->key = key;
     node->data = data;
@@ -540,7 +514,5 @@
     h->num_elements++;
     crHashIdPoolAllocId (h->idPool, key);
-#ifdef CHROMIUM_THREADSAFE
-    crUnlockMutex(&h->mutex);
-#endif
+    crUnlockMutex(&h->mutex);
 }
 
@@ -548,11 +520,8 @@
 {
     GLboolean fAllocated;
-#ifdef CHROMIUM_THREADSAFE
-    crLockMutex(&h->mutex);
-#endif
+
+    crLockMutex(&h->mutex);
     fAllocated = crHashIdPoolAllocId (h->idPool, key);
-#ifdef CHROMIUM_THREADSAFE
-    crUnlockMutex(&h->mutex);
-#endif
+    crUnlockMutex(&h->mutex);
     return fAllocated;
 }
@@ -560,11 +529,7 @@
 void crHashtableWalkKeys( CRHashTable *h, CRHashIdWalkKeys walkFunc , void *data)
 {
-#ifdef CHROMIUM_THREADSAFE
-    crLockMutex(&h->mutex);
-#endif
+    crLockMutex(&h->mutex);
     crHashIdWalkKeys(h->idPool, walkFunc , data);
-#ifdef CHROMIUM_THREADSAFE
-    crUnlockMutex(&h->mutex);
-#endif
+    crUnlockMutex(&h->mutex);
 }
 
@@ -573,7 +538,5 @@
     GLuint res;
 
-#ifdef CHROMIUM_THREADSAFE
-    crLockMutex(&h->mutex);
-#endif
+    crLockMutex(&h->mutex);
     res = crHashIdPoolAllocBlock (h->idPool, range);
 #ifdef DEBUG_misha
@@ -588,7 +551,5 @@
     }
 #endif
-#ifdef CHROMIUM_THREADSAFE
-    crUnlockMutex(&h->mutex);
-#endif
+    crUnlockMutex(&h->mutex);
     return res;
 }
@@ -599,7 +560,5 @@
     CRHashNode *temp, *beftemp = NULL;
 
-#ifdef CHROMIUM_THREADSAFE
-    crLockMutex(&h->mutex);
-#endif
+    crLockMutex(&h->mutex);
     for ( temp = h->buckets[index]; temp; temp = temp->next )
     {
@@ -623,7 +582,5 @@
     
     crHashIdPoolFreeBlock( h->idPool, key, 1 );
-#ifdef CHROMIUM_THREADSAFE
-    crUnlockMutex(&h->mutex);
-#endif
+    crUnlockMutex(&h->mutex);
 }
 
@@ -633,7 +590,5 @@
     CRHashNode *temp, *beftemp = NULL;
 
-#ifdef CHROMIUM_THREADSAFE
-    crLockMutex(&h->mutex);
-#endif
+    crLockMutex(&h->mutex);
     for (temp = h->buckets[index]; temp; temp = temp->next)
     {
@@ -657,7 +612,5 @@
 
     crHashIdPoolFreeBlock(h->idPool, key, 1);
-#ifdef CHROMIUM_THREADSAFE
-    crUnlockMutex(&h->mutex);
-#endif
+    crUnlockMutex(&h->mutex);
 }
 
@@ -676,7 +629,6 @@
     unsigned int index = crHash( key );
     CRHashNode *temp;
-#ifdef CHROMIUM_THREADSAFE
+
     crLockMutex((CRmutex *)&h->mutex);
-#endif
     for ( temp = h->buckets[index]; temp; temp = temp->next )
     {
@@ -684,7 +636,5 @@
             break;
     }
-#ifdef CHROMIUM_THREADSAFE
     crUnlockMutex((CRmutex *)&h->mutex);
-#endif
     if ( !temp )
     {
@@ -699,7 +649,6 @@
     unsigned int index = crHash( key );
     CRHashNode *temp;
-#ifdef CHROMIUM_THREADSAFE
-    crLockMutex(&h->mutex);
-#endif
+
+    crLockMutex(&h->mutex);
     for ( temp = h->buckets[index]; temp; temp = temp->next )
     {
@@ -707,7 +656,5 @@
             break;
     }
-#ifdef CHROMIUM_THREADSAFE
-    crUnlockMutex(&h->mutex);
-#endif
+    crUnlockMutex(&h->mutex);
     if ( !temp )
     {
@@ -715,7 +662,5 @@
         return;
     }
-#ifdef CHROMIUM_THREADSAFE
-    crLockMutex(&h->mutex);
-#endif
+    crLockMutex(&h->mutex);
     if ( temp->data && deleteFunc )
     {
@@ -723,7 +668,5 @@
     }
     temp->data = data;
-#ifdef CHROMIUM_THREADSAFE
-    crUnlockMutex(&h->mutex);
-#endif
+    crUnlockMutex(&h->mutex);
 }
 
@@ -753,7 +696,5 @@
         return rc;
 
-#ifdef CHROMIUM_THREADSAFE
     crLockMutex(&pHash->mutex);
-#endif
     for (i = 0; i<CR_NUM_BUCKETS && !rc; i++)
     {
@@ -770,8 +711,6 @@
         }
     }
-#ifdef CHROMIUM_THREADSAFE
+
     crUnlockMutex(&pHash->mutex);
-#endif
-
     return rc;
 }
Index: trunk/src/VBox/GuestHost/OpenGL/util/net.c
===================================================================
--- trunk/src/VBox/GuestHost/OpenGL/util/net.c	(revision 78263)
+++ trunk/src/VBox/GuestHost/OpenGL/util/net.c	(revision 78341)
@@ -48,7 +48,5 @@
     int                  num_clients; /* total number of clients (unused?) */
 
-#ifdef CHROMIUM_THREADSAFE
     CRmutex              mutex;
-#endif
 } cr_net;
 
@@ -134,7 +132,5 @@
     {
         crDebug("crNetConnectToServer() failed, freeing the connection");
-        #ifdef CHROMIUM_THREADSAFE
-            crFreeMutex( &conn->messageList.lock );
-        #endif
+        crFreeMutex( &conn->messageList.lock );
         conn->Disconnect(conn);
         crFree( conn );
@@ -219,7 +215,5 @@
 {
     conn->Disconnect(conn);
-    #ifdef CHROMIUM_THREADSAFE
-        crFreeMutex( &conn->messageList.lock );
-    #endif
+    crFreeMutex( &conn->messageList.lock );
     crFree(conn);
 }
@@ -244,7 +238,5 @@
         cr_net.use_hgcm    = 0;
         cr_net.num_clients = 0;
-#ifdef CHROMIUM_THREADSAFE
         crInitMutex(&cr_net.mutex);
-#endif
 
         cr_net.initialized = 1;
@@ -305,7 +297,5 @@
     if (!cr_net.initialized) return;
 
-#ifdef CHROMIUM_THREADSAFE
     crLockMutex(&cr_net.mutex);
-#endif
 
     /* Note, other protocols used by chromium should free up stuff too,
@@ -329,8 +319,6 @@
     cr_net.initialized = 0;
 
-#ifdef CHROMIUM_THREADSAFE
     crUnlockMutex(&cr_net.mutex);
     crFreeMutex(&cr_net.mutex);
-#endif
 }
 
@@ -380,8 +368,6 @@
     list->head = list->tail = NULL;
     list->numMessages = 0;
-#ifdef CHROMIUM_THREADSAFE
     crInitMutex(&list->lock);
     crInitCondition(&list->nonEmpty);
-#endif
 }
 
@@ -400,7 +386,5 @@
     CRMessageListNode *node;
 
-#ifdef CHROMIUM_THREADSAFE
     crLockMutex(&list->lock);
-#endif
 
     node = (CRMessageListNode *) crAlloc(sizeof(CRMessageListNode));
@@ -419,8 +403,6 @@
     list->numMessages++;
 
-#ifdef CHROMIUM_THREADSAFE
     crSignalCondition(&list->nonEmpty);
     crUnlockMutex(&list->lock);
-#endif
 }
 
@@ -437,7 +419,5 @@
     int retval;
 
-#ifdef CHROMIUM_THREADSAFE
     crLockMutex(&list->lock);
-#endif
 
     if (list->head) {
@@ -467,8 +447,5 @@
     }
 
-#ifdef CHROMIUM_THREADSAFE
     crUnlockMutex(&list->lock);
-#endif
-
     return retval;
 }
@@ -488,15 +465,9 @@
     CRMessageListNode *node;
 
-#ifdef CHROMIUM_THREADSAFE
     crLockMutex(&list->lock);
-#endif
-
-#ifdef CHROMIUM_THREADSAFE
+
     while (!list->head) {
         crWaitCondition(&list->nonEmpty, &list->lock);
     }
-#else
-    CRASSERT(list->head);
-#endif
 
     node = list->head;
@@ -518,8 +489,5 @@
 
     crFree(node);
-
-#ifdef CHROMIUM_THREADSAFE
     crUnlockMutex(&list->lock);
-#endif
 }
 
@@ -653,7 +621,5 @@
 {
     conn->Disconnect( conn );
-#ifdef CHROMIUM_THREADSAFE
     crFreeMutex( &conn->messageList.lock );
-#endif
     crFree( conn );
 }
Index: trunk/src/VBox/GuestHost/OpenGL/util/vboxhgcm.c
===================================================================
--- trunk/src/VBox/GuestHost/OpenGL/util/vboxhgcm.c	(revision 78263)
+++ trunk/src/VBox/GuestHost/OpenGL/util/vboxhgcm.c	(revision 78341)
@@ -169,8 +169,6 @@
     CRConnection         **conns;
     CRBufferPool         *bufpool;
-#ifdef CHROMIUM_THREADSAFE
     CRmutex              mutex;
     CRmutex              recvmutex;
-#endif
     CRNetReceiveFuncList *recv_list;
     CRNetCloseFuncList   *close_list;
@@ -637,8 +635,5 @@
     CRVBOXHGCMBUFFER *buf;
 
-#ifdef CHROMIUM_THREADSAFE
     crLockMutex(&g_crvboxhgcm.mutex);
-#endif
-
     buf = (CRVBOXHGCMBUFFER *) crBufferPoolPop(g_crvboxhgcm.bufpool, conn->buffer_size);
 
@@ -661,8 +656,5 @@
     }
 
-#ifdef CHROMIUM_THREADSAFE
     crUnlockMutex(&g_crvboxhgcm.mutex);
-#endif
-
     return (void *)( buf + 1 );
 
@@ -673,11 +665,7 @@
     void *pvBuff;
     VBOXCRHGSMIPROFILE_FUNC_PROLOGUE();
-#ifdef CHROMIUM_THREADSAFE
     crLockMutex(&g_crvboxhgcm.mutex);
-#endif
     pvBuff = _crVBoxHGCMAlloc(conn);
-#ifdef CHROMIUM_THREADSAFE
     crUnlockMutex(&g_crvboxhgcm.mutex);
-#endif
     VBOXCRHGSMIPROFILE_FUNC_EPILOGUE();
     return pvBuff;
@@ -730,11 +718,8 @@
 {
     VBOXCRHGSMIPROFILE_FUNC_PROLOGUE();
-#ifdef CHROMIUM_THREADSAFE
+
     crLockMutex(&g_crvboxhgcm.mutex);
-#endif
     _crVBoxHGCMWriteExact(conn, buf, len);
-#ifdef CHROMIUM_THREADSAFE
     crUnlockMutex(&g_crvboxhgcm.mutex);
-#endif
     VBOXCRHGSMIPROFILE_FUNC_EPILOGUE();
 }
@@ -908,8 +893,5 @@
     VBOXCRHGSMIPROFILE_FUNC_PROLOGUE();
 
-#ifdef CHROMIUM_THREADSAFE
     crLockMutex(&g_crvboxhgcm.mutex);
-#endif
-
     if (!bufp) /* We're sending a user-allocated buffer. */
     {
@@ -923,7 +905,5 @@
             crVBoxHGCMWriteReadExact(conn, start, len, CR_VBOXHGCM_USERALLOCATED);
 #endif
-#ifdef CHROMIUM_THREADSAFE
             crUnlockMutex(&g_crvboxhgcm.mutex);
-#endif
             VBOXCRHGSMIPROFILE_FUNC_EPILOGUE();
         return;
@@ -951,11 +931,7 @@
 
     /* Reclaim this pointer for reuse */
-#ifdef CHROMIUM_THREADSAFE
     crLockMutex(&g_crvboxhgcm.mutex);
-#endif
     crBufferPoolPush(g_crvboxhgcm.bufpool, hgcm_buffer, hgcm_buffer->allocated);
-#ifdef CHROMIUM_THREADSAFE
     crUnlockMutex(&g_crvboxhgcm.mutex);
-#endif
 
     /* Since the buffer's now in the 'free' buffer pool, the caller can't
@@ -965,8 +941,5 @@
     *bufp = NULL;
 
-#ifdef CHROMIUM_THREADSAFE
     crUnlockMutex(&g_crvboxhgcm.mutex);
-#endif
-
     VBOXCRHGSMIPROFILE_FUNC_EPILOGUE();
 }
@@ -1006,11 +979,7 @@
 {
     VBOXCRHGSMIPROFILE_FUNC_PROLOGUE();
-#ifdef CHROMIUM_THREADSAFE
     crLockMutex(&g_crvboxhgcm.mutex);
-#endif
     crVBoxHGCMReadExact(conn, buf, len);
-#ifdef CHROMIUM_THREADSAFE
     crUnlockMutex(&g_crvboxhgcm.mutex);
-#endif
     VBOXCRHGSMIPROFILE_FUNC_EPILOGUE();
 }
@@ -1028,7 +997,5 @@
     {
         case CR_VBOXHGCM_MEMORY:
-#ifdef CHROMIUM_THREADSAFE
             crLockMutex(&g_crvboxhgcm.mutex);
-#endif
             if (g_crvboxhgcm.bufpool) {
                 /** @todo o'rly? */
@@ -1038,7 +1005,5 @@
                 crBufferPoolPush(g_crvboxhgcm.bufpool, hgcm_buffer, hgcm_buffer->allocated);
             }
-#ifdef CHROMIUM_THREADSAFE
             crUnlockMutex(&g_crvboxhgcm.mutex);
-#endif
             break;
 
@@ -1055,11 +1020,7 @@
 {
     VBOXCRHGSMIPROFILE_FUNC_PROLOGUE();
-#ifdef CHROMIUM_THREADSAFE
     crLockMutex(&g_crvboxhgcm.mutex);
-#endif
     _crVBoxHGCMFree(conn, buf);
-#ifdef CHROMIUM_THREADSAFE
     crUnlockMutex(&g_crvboxhgcm.mutex);
-#endif
     VBOXCRHGSMIPROFILE_FUNC_EPILOGUE();
 }
@@ -1170,11 +1131,7 @@
 {
     VBOXCRHGSMIPROFILE_FUNC_PROLOGUE();
-#ifdef CHROMIUM_THREADSAFE
     crLockMutex(&g_crvboxhgcm.mutex);
-#endif
     _crVBoxHGCMReceiveMessage(conn);
-#ifdef CHROMIUM_THREADSAFE
     crUnlockMutex(&g_crvboxhgcm.mutex);
-#endif
     VBOXCRHGSMIPROFILE_FUNC_EPILOGUE();
 }
@@ -1402,8 +1359,5 @@
     if (!g_crvboxhgcm.initialized) return;
 
-#ifdef CHROMIUM_THREADSAFE
     crLockMutex(&g_crvboxhgcm.mutex);
-#endif
-
     VBOXCRHGSMIPROFILE_FUNC_PROLOGUE();
 
@@ -1425,7 +1379,5 @@
     VBOXCRHGSMIPROFILE_FUNC_EPILOGUE();
 
-#ifdef CHROMIUM_THREADSAFE
     crUnlockMutex(&g_crvboxhgcm.mutex);
-#endif
 }
 
@@ -1433,12 +1385,8 @@
 {
     VBOXCRHGSMIPROFILE_FUNC_PROLOGUE();
-#ifdef CHROMIUM_THREADSAFE
     crLockMutex(&g_crvboxhgcm.mutex);
-#endif
     _crVBoxHGCMFree(conn, mess);
     CRASSERT(FALSE);
-#ifdef CHROMIUM_THREADSAFE
     crUnlockMutex(&g_crvboxhgcm.mutex);
-#endif
     VBOXCRHGSMIPROFILE_FUNC_EPILOGUE();
 }
@@ -1543,9 +1491,5 @@
 
     VBOXCRHGSMIPROFILE_FUNC_PROLOGUE();
-
-#ifdef CHROMIUM_THREADSAFE
     crLockMutex(&g_crvboxhgcm.mutex);
-#endif
-
     pClient = _crVBoxHGSMIClientGet(conn);
     if (pClient)
@@ -1559,8 +1503,5 @@
     }
 
-#ifdef CHROMIUM_THREADSAFE
     crUnlockMutex(&g_crvboxhgcm.mutex);
-#endif
-
     VBOXCRHGSMIPROFILE_FUNC_EPILOGUE();
 
@@ -1571,11 +1512,7 @@
 {
     VBOXCRHGSMIPROFILE_FUNC_PROLOGUE();
-#ifdef CHROMIUM_THREADSAFE
     crLockMutex(&g_crvboxhgcm.mutex);
-#endif
     _crVBoxHGSMIFree(conn, buf);
-#ifdef CHROMIUM_THREADSAFE
     crUnlockMutex(&g_crvboxhgcm.mutex);
-#endif
     VBOXCRHGSMIPROFILE_FUNC_EPILOGUE();
 }
@@ -1921,8 +1858,5 @@
     VBOXCRHGSMIPROFILE_FUNC_PROLOGUE();
 
-#ifdef CHROMIUM_THREADSAFE
     crLockMutex(&g_crvboxhgcm.mutex);
-#endif
-
     if (!bufp) /* We're sending a user-allocated buffer. */
     {
@@ -1939,7 +1873,5 @@
             _crVBoxHGSMIWriteReadExact(conn, pClient, (void*)start, 0, len, false);
 #endif
-#ifdef CHROMIUM_THREADSAFE
             crUnlockMutex(&g_crvboxhgcm.mutex);
-#endif
             VBOXCRHGSMIPROFILE_FUNC_EPILOGUE();
             return;
@@ -1948,7 +1880,5 @@
         /* fallback */
         crVBoxHGCMSend(conn, bufp, start, len);
-#ifdef CHROMIUM_THREADSAFE
         crUnlockMutex(&g_crvboxhgcm.mutex);
-#endif
         VBOXCRHGSMIPROFILE_FUNC_EPILOGUE();
         return;
@@ -1967,7 +1897,5 @@
         /* fallback */
         crVBoxHGCMSend(conn, bufp, start, len);
-#ifdef CHROMIUM_THREADSAFE
         crUnlockMutex(&g_crvboxhgcm.mutex);
-#endif
         VBOXCRHGSMIPROFILE_FUNC_EPILOGUE();
         return;
@@ -1984,7 +1912,5 @@
     {
         crVBoxHGCMSend(conn, bufp, start, len);
-#ifdef CHROMIUM_THREADSAFE
         crUnlockMutex(&g_crvboxhgcm.mutex);
-#endif
         VBOXCRHGSMIPROFILE_FUNC_EPILOGUE();
         return;
@@ -2019,8 +1945,5 @@
     *bufp = NULL;
 
-#ifdef CHROMIUM_THREADSAFE
     crUnlockMutex(&g_crvboxhgcm.mutex);
-#endif
-
     VBOXCRHGSMIPROFILE_FUNC_EPILOGUE();
 }
@@ -2048,16 +1971,10 @@
     VBOXCRHGSMIPROFILE_FUNC_PROLOGUE();
 
-#ifdef CHROMIUM_THREADSAFE
     crLockMutex(&g_crvboxhgcm.mutex);
-#endif
-
     CRASSERT(0);
 
     _crVBoxHGCMReceiveMessage(conn);
 
-#ifdef CHROMIUM_THREADSAFE
     crUnlockMutex(&g_crvboxhgcm.mutex);
-#endif
-
     VBOXCRHGSMIPROFILE_FUNC_EPILOGUE();
 }
@@ -2083,8 +2000,5 @@
     int rc = VINF_SUCCESS;
 
-#ifdef CHROMIUM_THREADSAFE
     crLockMutex(&g_crvboxhgcm.mutex);
-#endif
-
     VBOXCRHGSMIPROFILE_FUNC_PROLOGUE();
 
@@ -2119,7 +2033,5 @@
     VBOXCRHGSMIPROFILE_FUNC_EPILOGUE();
 
-#ifdef CHROMIUM_THREADSAFE
     crUnlockMutex(&g_crvboxhgcm.mutex);
-#endif
     return RT_SUCCESS(rc);
 }
@@ -2133,8 +2045,5 @@
     VBOXCRHGSMIPROFILE_FUNC_PROLOGUE();
 
-#ifdef CHROMIUM_THREADSAFE
     crLockMutex(&g_crvboxhgcm.mutex);
-#endif
-
     fHasActiveCons = _crVBoxCommonDoDisconnectLocked(conn);
 
@@ -2153,8 +2062,5 @@
 
     VBOXCRHGSMIPROFILE_FUNC_EPILOGUE();
-
-#ifdef CHROMIUM_THREADSAFE
     crUnlockMutex(&g_crvboxhgcm.mutex);
-#endif
 }
 
@@ -2162,14 +2068,10 @@
 {
     VBOXCRHGSMIPROFILE_FUNC_PROLOGUE();
-#ifdef CHROMIUM_THREADSAFE
     crLockMutex(&g_crvboxhgcm.mutex);
-#endif
     CRASSERT(0);
 
     _crVBoxHGSMIFree(conn, mess);
 
-#ifdef CHROMIUM_THREADSAFE
     crUnlockMutex(&g_crvboxhgcm.mutex);
-#endif
     VBOXCRHGSMIPROFILE_FUNC_EPILOGUE();
 }
@@ -2212,8 +2114,6 @@
 #endif
 
-#ifdef CHROMIUM_THREADSAFE
     crInitMutex(&g_crvboxhgcm.mutex);
     crInitMutex(&g_crvboxhgcm.recvmutex);
-#endif
     g_crvboxhgcm.bufpool = crBufferPoolInit(16);
 
@@ -2253,7 +2153,5 @@
     if (!g_crvboxhgcm.initialized) return;
 
-#ifdef CHROMIUM_THREADSAFE
     crLockMutex(&g_crvboxhgcm.mutex);
-#endif
 
     /* Connection count would be changed in calls to crNetDisconnect, so we have to store original value.
@@ -2275,9 +2173,7 @@
     g_crvboxhgcm.bufpool = NULL;
 
-#ifdef CHROMIUM_THREADSAFE
     crUnlockMutex(&g_crvboxhgcm.mutex);
     crFreeMutex(&g_crvboxhgcm.mutex);
     crFreeMutex(&g_crvboxhgcm.recvmutex);
-#endif
 
     crFree(g_crvboxhgcm.conns);
@@ -2364,7 +2260,6 @@
 #endif
 
-#ifdef CHROMIUM_THREADSAFE
     crLockMutex(&g_crvboxhgcm.mutex);
-#endif
+
     /* Find a free slot */
     for (i = 0; i < g_crvboxhgcm.num_conns; i++) {
@@ -2384,7 +2279,5 @@
         g_crvboxhgcm.conns[g_crvboxhgcm.num_conns++] = conn;
     }
-#ifdef CHROMIUM_THREADSAFE
     crUnlockMutex(&g_crvboxhgcm.mutex);
-#endif
 }
 
@@ -2443,7 +2336,5 @@
     VBOXCRHGSMIPROFILE_FUNC_PROLOGUE();
 
-#ifdef CHROMIUM_THREADSAFE
     crLockMutex(&g_crvboxhgcm.mutex);
-#endif
 
 #ifdef IN_GUEST
@@ -2479,8 +2370,5 @@
     }
 
-#ifdef CHROMIUM_THREADSAFE
     crUnlockMutex(&g_crvboxhgcm.mutex);
-#endif
-
     VBOXCRHGSMIPROFILE_FUNC_EPILOGUE();
 